'' ============================================================
'' 2D Vector Functions
''
'' Copyright (C) 2006 - Jeff Marshall (coder@execulink.com)
''
'' License: 1) Program is provided as-is.  
''          2) There is no warranty or guarantee.
''          3) There are no other conditions.
''
'' Feel free to use, re-use, or abuse :)
''
'' ============================================================

Option Explicit

#include "vector.bi"

sub VAdd (v AS Vector, a AS Vector, b AS Vector)
  v.x = a.x + b.x
  v.y = a.y + b.y
end sub
sub VAdd2V (v AS Vector, a AS Vector)
  v.x = v.x + a.x
  v.y = v.y + a.y
end sub
sub VAddComp (v AS Vector, a AS Vector, x as single, y as single)
  v.x = a.x + x
  v.y = a.y + y
end sub
sub VAddComp2V (v AS Vector, x as single, y as single)
  v.x = v.x + x
  v.y = v.y + y
end sub
sub VAddMul (v AS Vector, k1 as single, a AS Vector, k2 as single, b AS Vector)
  v.x = k1 * a.x + k2 * b.x
  v.y = k1 * a.y + k2 * b.y
end sub
function VDist (a AS Vector, b AS Vector) as single
  dim v AS Vector
  VSub v, a, b
  VDist = VMag(v)
end function
sub VLimit2V (v AS Vector, d as single)
  if v.x > d then v.x = d
  if v.x < -d then v.x = -d
  if v.y > d then v.y = d
  if v.y < -d then v.y = -d
end sub
function VMag (v AS Vector) as single
  VMag = SQR(v.x * v.x + v.y * v.y)
end function
sub VNeg (v AS Vector, a AS Vector)
  VScale v, a, -1
end sub
sub VNeg2V (v AS Vector)
  VScale2V v, -1
end sub
sub VScale (v AS Vector, a AS Vector, k as single)
  v.x = k * a.x
  v.y = k * a.y
end sub
sub VScale2V (v AS Vector, k as single)
  v.x = k * v.x
  v.y = k * v.y
end sub
sub VSet (v AS Vector, x as single, y as single)
  v.x = x
  v.y = y
end sub
sub VSub (v AS Vector, a AS Vector, b AS Vector)
  v.x = a.x - b.x
  v.y = a.y - b.y
end sub
sub VSub2V (v AS Vector, a AS Vector)
  v.x = v.x - a.x
  v.y = v.y - a.y
end sub
sub VSubComp (v AS Vector, a AS Vector, x as single, y as single)
  v.x = a.x - x
  v.y = a.y - y
end sub


sub VRot2V (v AS Vector, r as single)
  dim a AS Vector
  a.x = v.x * COS(r) + v.y * SIN(r)
  a.y = -v.x * SIN(r) + v.y * COS(r)
  v = a
end sub
sub VRot902V (v AS Vector)
  dim a AS Vector
  a = v
  v.x = -a.y
  v.y = a.x
end sub
